279. Perfect Squares(难)

Given a positive integer n, find the least number of perfect square numbers (for example, 1, 4, 9, 16, ...) which sum to n.

For example, given n = 12, return 3 because 12 = 4 + 4 + 4; given n = 13, return 2 because 13 = 4 + 9.

类似于背包问题。

dp[i]表示i可以表示成平方的最少个数。则

dp[i + j*j] = min(dp[i + j*j], dp[i] + 1);

class Solution {
public:
	int numSquares(int n) {
		vector dp(n+1,INT_MAX);
		dp[0] = 0;
		for (int i = 0; i <= n; i++){
			for (int j = 0; i+j*j <= n; j++){
				dp[i + j*j] = min(dp[i + j*j], dp[i] + 1);
			}
		}
		return dp[n];
	}
};


你可能感兴趣的:(leetcode)